# include <iostream>
# include <queue>
# include <vector>
# include <tuple>
# include <climits>
using namespace std;

struct liniq
{
    long long type,c;
    vector<long long> adj;
};

long long n,m,k;
const int MAX=1e6+1;
const long long INF=LLONG_MAX;
liniq line[MAX];
vector<long long> a[MAX];
pair<long long, long long> dist[MAX];

void dijkstra()
{
    for(int i=1;i<=n;i++)
    {
        dist[i]={INF,INF};
    }

    priority_queue<tuple<long long, long long, long long>> q;
    dist[1]={0,0};
    q.push(make_tuple(0,0,1));

    while(q.size()>0)
    {
        int money,tram,curr;
        tie(money,tram,curr)=q.top();
        money=-money;
        tram=-tram;
        q.pop();

        if(money>dist[curr].first or (money==dist[curr].first and tram>dist[curr].second)) continue;

       // cout<<money<<" "<<tram<<" "<<curr<<"//////////////////"<<endl;

        for(auto lines: a[curr])
        {
            for(auto next: line[lines].adj)
            {
                if(line[lines].type==0)
                {
                    //if(next==n) cout<<0<<" "<<next<<endl;
                    if(money+line[lines].c<dist[next].first or (money+line[lines].c==dist[next].first and tram<dist[next].second))
                    {
                        dist[next]={money+line[lines].c,tram};
                        q.push(make_tuple(-dist[next].first,-dist[next].second,next));
                    }
                }
                else
                {
                    if(money+line[lines].c<dist[next].first or (money+line[lines].c==dist[next].first and tram+1<dist[next].second))
                    {
                        //if(next==n) cout<<1<<" "<<next<<endl;
                        dist[next]={money+line[lines].c,tram+1};
                        //cout<<dist[next].first<<" "<<dist[next].second<<endl;
                        q.push(make_tuple(-dist[next].first,-dist[next].second,next));
                    }
                }

                //if(next==n) cout<<dist[next].first<<" "<<dist[next].second<<" "<<money<<" "<<line[lines].c<<endl;
            }
        }
    }

    cout<<dist[n].first<<" "<<dist[n].second<<endl;

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>m>>k;
    for(int i=1;i<=k;i++)
    {
        cin>>line[i].type;
    }

    for(int i=1;i<=k;i++)
    {
        cin>>line[i].c;
    }

    for(int i=1;i<=m;i++)
    {
        long long x,y,l;
        cin>>x>>y>>l;

        a[x].push_back(l);
        a[y].push_back(l);
        line[l].adj.push_back(x);
        line[l].adj.push_back(y);
    }

    dijkstra();
    return 0;
}
