#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int maxn = 100005;
const int maxk = 1000005;
const long long inf = (1LL << 62);

int n, m, k;

int type[maxn];
int cost[maxn];

vector<pair<int, int>> g[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m >> k;

    for (int i = 1; i <= k; ++i)
    {
        cin >> type[i];
    }

    for (int i = 1; i <= k; ++i)
    {
        cin >> cost[i];
    }

    for (int i = 1; i <= m; ++i)
    {
        int x, y, t;
        cin >> x >> y >> t;

        g[x].push_back(make_pair(y, t));
        g[y].push_back(make_pair(x, y));
    }

    vector<long long> dist(n + 5, inf);
    dist[1] = 0;

    priority_queue<pair<long long, int>> pq;
    pq.push(make_pair(0LL, 1));

    while (!pq.empty())
    {
        int node = pq.top().second;
        long long curr = -pq.top().first;

        pq.pop();

        if (dist[node] < curr)
        {
            continue;
        }

        for (auto [nxt, d] : g[node])
        {
            long long path = cost[d] + curr;

            if (dist[nxt] > path)
            {
                dist[nxt] = path;
                pq.push(make_pair(-path, nxt));
            }
        }
    }

    cout << dist[n] << endl;

    return 0;
}
