#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int maxn = 100005;
const int maxk = 1000005;
const long long inf = (1LL << 62);

int n, m, k;

int type[maxk];
int cost[maxk];

vector<pair<int, int>> g[maxn];

void solve1()
{
    vector<long long> dist(n + 5, inf);
    dist[1] = 0;

    priority_queue<pair<long long, int>> pq;
    pq.push(make_pair(0LL, 1));

    while (!pq.empty())
    {
        int node = pq.top().second;
        long long curr = -pq.top().first;

        pq.pop();

        if (dist[node] < curr)
        {
            continue;
        }

        for (auto [nxt, d] : g[node])
        {
            long long path = cost[d] + curr;

            if (dist[nxt] > path)
            {
                dist[nxt] = path;
                pq.push(make_pair(-path, nxt));
            }
        }
    }

    cout << dist[n] << " " << 0 << endl;
}

bool bf[20];
bool visited[maxn];

long long ans = inf;
int ans_cnt = 0;

void dfs(int node)
{
    visited[node] = 1;

    for (auto [v, d] : g[node])
    {
        if (bf[d] && !visited[v])
        {
            dfs(v);
        }
    }
}

void f(int pos)
{
    if (pos == k + 1)
    {
        for (int i = 1; i <= n; ++i)
        {
            visited[i] = false;
        }

        long long c = 0;
        int cnt = 0;

        for (int i = 1; i <= k; ++i)
        {
            if (bf[i] == 1)
            {
                cnt += type[i];
                c += cost[i];
            }
        }

        if (c == 0)
        {
            return;
        }

        dfs(1);

        if (visited[n] == 1)
        {
            if (ans > c)
            {
                ans = c;
                ans_cnt = cnt;
            }
            else if (ans == c)
            {
                ans_cnt = min(ans_cnt, cnt);
            }
        }

        return;
    }

    for (int i = 0; i <= 1; ++i)
    {
        bf[pos] = i;
        f(pos + 1);
    }
}

const int maxn2 = 1005;
const int maxk2 = 1005;

long long dist[maxn2][maxk2];
int dist2[maxn2][maxk2];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m >> k;

    for (int i = 1; i <= k; ++i)
    {
        cin >> type[i];
    }

    for (int i = 1; i <= k; ++i)
    {
        cin >> cost[i];
    }

    for (int i = 1; i <= m; ++i)
    {
        int x, y, t;
        cin >> x >> y >> t;

        g[x].push_back(make_pair(y, t));
        g[y].push_back(make_pair(x, t));
    }

    if (k == m)
    {
        solve1();
        return 0;
    }

    if (k <= 15)
    {
        f(1);

        cout << ans << ' ' << ans_cnt << endl;

        return 0;
    }


    for (int i = 2; i <= n; ++i)
    {
        for (int j = 0; j <= k; ++j)
        {
            dist[i][j] = inf;
            dist2[i][j] = inf;
        }
    }

    priority_queue<pair<long long, pair<int, int>>> pq;

    pq.push(make_pair(0LL, make_pair(1, 0)));

    while (!pq.empty())
    {
        long long curr = -pq.top().first;
        int node = pq.top().second.first;
        int currl = pq.top().second.second;

        pq.pop();

        if (dist[node][currl] < curr)
        {
            continue;
        }

        for (auto [nxt, d] : g[node])
        {
            long long path = curr + (d == currl ? 0 : cost[d]);

            if (dist[nxt][d] > path)
            {
                dist[nxt][d] = path;
                pq.push(make_pair(-path, make_pair(nxt, d)));
            }
            else if (dist[nxt][d] == path)
            {
                dist2[nxt][d] = min(dist2[nxt][d], type[d] + dist2[node][currl]);
            }
        }
    }

    long long ans = inf;
    long long ans2 = inf;

    for (int i = 1; i <= k; ++i)
    {
        ans2 = min(ans2, 1LL * dist2[n][i]);
        ans = min(ans, dist[n][i]);
    }

    cout << ans << " " << ans2 << endl;

    return 0;
}
