#include <iostream>
#include <vector>
#include <queue>
#include <map>

using namespace std;

const int maxn = 100005;
const int maxk = 1000005;
const long long inf = (1LL << 62);

int n, m, k;

int type[maxk];
int cost[maxk];

vector<pair<int, int>> g[maxn];

map<pair<int, int>, long long> dist;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m >> k;

    for (int i = 1; i <= k; ++i)
    {
        cin >> type[i];
    }

    for (int i = 1; i <= k; ++i)
    {
        cin >> cost[i];
    }

    for (int i = 1; i <= m; ++i)
    {
        int x, y, t;
        cin >> x >> y >> t;

        g[x].push_back(make_pair(y, t));
        g[y].push_back(make_pair(x, t));
    }

    priority_queue<pair<long long, pair<int, int>>> pq;

    for (int i = 0; i <= k; ++i)
    {
        dist[make_pair(1, i)] = 0;
    }

    pq.push(make_pair(0LL, make_pair(1, 0)));

    while (!pq.empty())
    {
        long long curr = -pq.top().first;
        int node = pq.top().second.first;
        int currl = pq.top().second.second;

        //cout << curr << ' ' << node << endl;

        pq.pop();

        if (dist.find(make_pair(node, currl)) != dist.end() && dist[make_pair(node, currl)] < curr)
        {
            continue;
        }

        dist[make_pair(node, currl)] = curr;

        //if (node == n)
        //{
            //cout << dist[make_pair(node, currl)] << endl;
        //}

        for (auto [nxt, d] : g[node])
        {
            long long path = curr + (d == currl ? 0 : cost[d]);

            if (dist.find(make_pair(nxt, d)) == dist.end() || dist[make_pair(nxt, d)] > path)
            {
                dist[make_pair(nxt, d)] = path;
                pq.push(make_pair(-path, make_pair(nxt, d)));
            }
        }
    }

    long long ans = inf;
    long long ans2 = inf;

    for (int i = 1; i <= k; ++i)
    {
        if (dist.find(make_pair(n, i)) == dist.end())
        {
            continue;
        }

        ans = min(ans, dist[make_pair(n, i)]);
    }

    cout << ans << " " << 0 << endl;

    return 0;
}
