#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;
const int MAXK = 1000007;
const int MAXN = 100007;
const int MNOGO = 1e10;

int n, m, k;
vector<pair<int, int>> G[MAXN]; /// Graph
bool lineTypes[MAXK];
int prices[MAXK];

int dist[MAXN];
bool visited[MAXN];
bool used[MAXK];
int from[MAXN];

void dijkstra(int start){
    for(int i = 0; i < n; i++){ dist[i] = MNOGO; visited[i] = false; }
    for(int i = 0; i < k; i++){ used[i] = false; }
    dist[start] = 0;

    priority_queue<pair<int, int>> pq;
    pq.push({0, start});
    while(!pq.empty()){
        int curr = pq.top().second;
        int currDist = -pq.top().first;
        pq.pop();
        visited[curr] = true;
        for(int i = 0; i < G[curr].size(); i++){
            int next = G[curr][i].first;
            if(visited[next]){ continue; }
            int line = G[curr][i].second;
            int toNext = 0;
            if(!used[line]){
                toNext = prices[line];
            }
            if(dist[next] >= dist[curr] + toNext){
                dist[next] = dist[curr] + toNext;
                from[next] = curr;
            }
            pq.push({-dist[next], next});
        }
    }
}

int main(){
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);

    cin >> n >> m >> k;
    for(int i = 0; i < k; i++){
        cin >> lineTypes[i];
    }
    for(int i = 0; i < k; i++){
        cin >> prices[i];
    }

    for(int i = 0; i < m; i++){
        int u, v, t;
        cin >> u >> v >> t;
        u--; v--; t--;
        G[u].push_back({v, t});
        G[v].push_back({u, t});
    }

    dijkstra(0);
    cout << dist[n-1] << " 0\n";
//    for(int i = n-1; i != 0; i=from[i]){
//        cout << i+1 << '\n';
//    }

    return 0;
}
